include "../rx/macros"

format elf

include "system_netbsd.inc"
public _start   
bss_writeable:
add_data_section:
section ".text"

_start:
        pop dword [arg_count]
        pop dword [args]
        call bootstrap_rx
        upsh boot_netbsd
        upsh [boot_netbsd.size]
        call eval
        jmp boot

arg_count dd 0
args      dd 0
code 'cmdline', _cmdline
        upsh [args]
next
code '#args', _num_args
        upsh [arg_count]
next

;---------------------------------------------------------------------
; BSD syscall interface
; Description:
; syscall ( args argcount syscall# -- result flag )
; args: as few as 0 or as many as 6 arguments
; argcount: the number of arguments
; syscall-number: a number from /usr/include/asm/unistd.h
; This calling convention was borrowed from Marcel Hendrix's port of 
; eforth for Linux.
macro system A {
        push    0
        mov     eax,A
        int     80h
        setc    dl
}

code 'bsd-syscall', _syscall
        upop edx                ; Save the system call #
.syscall_0:
        cmp eax,0               ; Is this a zero argument system call?
        jnz .syscall_1
        system  edx
        add     esp,4
        jmp .syscall_exit
.syscall_1:
        cmp eax, 1              ; Is this a one argument system call?
        jnz .syscall_2          ;
        drop                    ; Forget the count
        push eax                ; Argument #1
        system  edx
        add esp, 4+4              ; Clean up return stack
        jmp .syscall_exit       ;
.syscall_2:                     ; Is this a two argument system call?
        cmp eax, 2              ;
        jnz .syscall_3          ;
        drop                    ;
        push eax                ; Argument #1
        drop                    ;
        push eax                ; Argument #2
        system  edx
        add esp, (2*4)+4            ;
        jmp .syscall_exit       ;
.syscall_3:                     ; Is this a three argument system call?
        cmp eax, 3              ;
        jnz .syscall_4          ;
        drop                    ;
        push eax                ; Argument #1
        drop                    ;
        push eax                ; Argument #2
        drop                    ;
        push eax                ; Argument #3
        system edx              ; Do the system call
        add esp, (3*4)+4            ;
        jmp .syscall_exit       ;
.syscall_4:                     ;
        cmp eax, 4              ; Is this a four argument system call?
        jnz .syscall_5          ;
        drop                    ;
        push eax                ; Argument #1
        drop                    ;
        push eax                ; Argument #2
        drop                    ;
        push eax                ; Argument #3
        drop                    ;
        push eax                ; Argument #4
        system edx              ; Do the system call
        add esp, (4*4)+4            ;
        jmp .syscall_exit       ;
.syscall_5:                     ; Five arguments?
        cmp eax, 5              ;
        jnz .syscall_6          ;
        drop                    ;
        push eax                ; Argument #1
        drop                    ;
        push eax                ; Argument #2
        drop                    ;
        push eax                ; Argument #3
        drop                    ;
        push eax                ; Argument #4
        drop                    ;
        push eax                ; Argument #5
        system edx              ; Do the system call
        add esp, (5*4)+4            ;
        jmp .syscall_exit       ;
.syscall_6:                     ; Six arguments?
        cmp eax, 6              ;
        jnz .syscall_exit       ; If not between 1-6, exit
        drop                    ;
        push eax                ; Argument #1
        drop                    ;
        push eax                ; Argument #2
        drop                    ;
        push eax                ; Argument #3
        drop                    ;
        push eax                ; Argument #4
        drop                    ;
        push eax                ; Argument #5
        drop                    ;
        push eax                ; Argument #6
        system  edx
        add esp, (6*4)+4            ;
.syscall_exit:
        dup
        movzx   eax,dl
next

boot_netbsd:
	include "../modules.inc"
	file "netbsd.f"
.size dd $-boot_netbsd
;---------------------------------------------------------------------
code 'boot', boot
next
;---------------------------------------------------------------------
include "../rx/rx"
